\documentclass{scrartcl}
\usepackage[top=1in, bottom=1.25in, left=1.25in, right=1.25in]{geometry}
\usepackage{array}
\usepackage[utf8x]{inputenc}
\usepackage[ngerman]{babel}
\usepackage{algorithm2e}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{lmodern}
\usepackage{stmaryrd}
%\usepackage{kpfonts}
\usepackage{tikz}
\usepackage{mathtools}
\usepackage{url}
\usepackage{microtype}
\DeclarePairedDelimiter{\ceil}{\lceil}{\rceil}	%Runden
\usetikzlibrary{trees}	%Bäume
\usetikzlibrary{positioning,calc,shapes,chains,arrows}

\setlength{\parindent}{0em}
\newcommand{\vcenteredinclude}[1]{\begingroup
\setbox0=\hbox{#1}%
\parbox{\wd0}{\box0}\endgroup}
\newcolumntype{P}[1]{>{\raggedright\arraybackslash}p{#1}}

\tikzset{
itria/.style={
  draw,dashed,shape border uses incircle,
  isosceles triangle,shape border rotate=90,yshift=-1.5cm}}

\pagenumbering{gobble}
\def\kuller{\bigcirc}
\newcommand{\shouldequal}{\overset{!}{=}}

\pagestyle{plain}

\begin{document}
\begin{center}$ $
{\fontsize{24}{10} \selectfont
\textbf{Artificial Life}$ $\\
$ $\\
\underline{Sheet 6}
}\\
\vspace{2em}
\begin{minipage}[t]{0.49\textwidth}
{\fontsize{15}{20} \raggedright \selectfont
Group \textbf{A}\\
Wed, 8-10h\\
$ $\\
}
\end{minipage}
\begin{minipage}[t]{0.49\textwidth}
{\fontsize{15}{20} \raggedleft \selectfont 
Tobias Kremeyer\\
}\end{minipage}
\end{center}
%\vspace{1em}
%{\fontsize{15}{20} \selectfont \setlength\extrarowheight{10pt}
%\begin{tabular}{|c||c|c||c|c||c|c||c|c||c|c|}
%\hline
%\textbf{Punkte:} & A1 & \hspace{1.7em} & A2 & \hspace{1.7em} & A3 & \hspace{1.7em} & A4 & \hspace{1.7em} & $\Sigma$ & \hspace{2.4em} \\
%\hline
%\end{tabular}}

\section*{A39)}
\textbf{Given:} $$N(s) = a\frac{1}{s^\alpha}$$
\textbf{Claim:} $N(s)$ yields linear dependency in log-log-plot.

\textbf{Proof:}\\
A log-log-plot $N'(s')$ (for rescaled values $N'$ and $s'$) of a function $N(s)$ is defined by
$$N'(s') = log_b(N(s')) = log_b(a\frac{1}{s'^\alpha}) = log_b(a\frac{1}{{(b^s)}^\alpha})$$

This yields:
\begin{eqnarray*}
N'(s') =& log_b\left(a\dfrac{1}{{(b^s)}^\alpha}\right)\\
=& log_b(a) - log_b({(b^s)}^\alpha)\\
=& log_b(a) - \alpha \cdot log_b(b^s)\\
=& log_b(a) - \alpha \cdot s
\end{eqnarray*}
which is linear for fixed values of $a$ and $\alpha$.
\begin{flushright}
$\square$
\end{flushright}

\section*{A40)}
\textbf{Claim:} $N(s)$ is scale invariant, i.e. $N(\lambda s) = C(\lambda)N(s)$\\

\textbf{Proof:} 
\begin{eqnarray*}
N(\lambda s) =& \dfrac{a}{(\lambda s)^\alpha}\\
=& \dfrac{a}{\lambda^\alpha s^\alpha}\\
=& \dfrac{1}{\lambda^\alpha} \cdot \dfrac{a}{s^\alpha} = C(\lambda) \cdot N(s)
\end{eqnarray*}
for $C(\lambda) := \dfrac{1}{\lambda^\alpha}$.
\begin{flushright}
$\square$
\end{flushright}

Besides $N$, also e.g. linear maps are scale invariant by definition (homogenity)

\section*{A41) Zipf's Law}
To check if Zipf's Law is valid for source code of programs, one should consider as data the source codes of many programs, count the occurrences of individual words and rank the words in a list. Let $f(n)$ denote the frequency of the word with rank $n$. Let $N$ be the number of different words. Then an exponent $\alpha$ should be searched such that $err_\alpha = \sum\limits_{n=1}^{N} \left( \dfrac{1}{n^\alpha} - f(n) \right)^2$ is minimal. If $err_\alpha$ is small enough, Zipf's law can be considered as valid, otherwise not.

A problem to focus is what should be defined as a \textit{word} in this context. Usually, in programming languages there are different types of tokens, such as keywords (\texttt{int}, \texttt{while}, \texttt{return}), constants (\texttt{41.9}, \texttt{0b101010}, \texttt{NULL}), identifiers (\texttt{myVariable}), strings (\texttt{"Hello world\textbackslash n"}) which may have escaped characters, operators (\texttt{+=}, \texttt{[]}), symbols (\texttt{;}, \texttt{//}) and comments. 

I propose to count keywords as they are, count constants as they are (but normalize number constants to a general representation such that 41f, 41.0 and 41.000 refer to the same value), count identifiers as they are, tokenize string constants into single words where escaped characters are a single token, count operators and symbols as they are and tokenize comments into single words.

\section*{A42) Exponential Decay}
Let $P(t)$ denote the pheromone concentration at iteration $t$. Let $P_0$ denote the initial pheromone concentration at $t=0$. This can be expressed as an exponential decay formula:
$$P(t) = P_0 e^{-\lambda t}$$
After 42 steps of iteration ($t = 42$) there should be 10\% of the pheromines left:
\begin{eqnarray*}
P_0 e^{-\lambda 42} = P(42) =& 0.1 P_0 &{| : P_0}\\
e^{-\lambda 42} =& 0.1 &{| ln}\\
-42\lambda =& ln(0.1) &{| : -42}\\
\lambda =& -\dfrac{ln(0.1)}{42} \approx 0.055
\end{eqnarray*}

Therefore, the concentration for iteration $t$ is given by
$$P(t) = P_0 e^{-t\cdot(ln(0.1)/42)} \approx P_0 e^{-0.055t}$$

\section*{A43) Drawbacks of Gradient Descent}
\begin{itemize}
\item \textbf{Local Minima.} Gradient Descent always searches local minima and terminates when it finds one. This may yield bad results if the algorithm stops in a bad local minimum. For cost functions with lots of local minima it is unlikely that the algorithm finds the global minimum.
\item \textbf{Flat Plateaus.} When grad. desc. encounters a flat plateau of the cost function, it becomes very slow or even may come to a full stop at some point with derivative = 0. Since the cost function is unknown, the user may think that a minimum is reached while the flat plateau may not be a local minimum (and could even be a local maximum!)
\item \textbf{Steep Valleys.} If the step width is chosen too high, the algorithm may ''jump'' over steep valleys and therefore dismiss the local minimum. Also, it could get stuck in the steep valley, but never reach the local minimum due to a step width which is too high.
\end{itemize}

\section*{A44) Random Search / Optimization}
For a cost function $f: \mathbb{R}^n \rightarrow \mathbb{R}$ let $x \in \mathbb{R}^n$ be the best position found in the search space ($f(x)$ minimal).
\paragraph*{Commonalities.}
Both algorithms begin by initializing the vector $x$ to a random position in the search space. Then in each step they sample a new point $y$ from the known point $x$. If $f(y) < f(x)$, the new point is better and therefore the algorithms set $x \leftarrow y$. Both algorithms terminate if a predefined criterion is met (e.g. a cost threshold is reached or the programmer gets bored).

\paragraph*{Differences.}
The algorithms differ in the way how they sample a new point $y$ from $x$. Random Optimization adds a \textbf{normally distributed} random vector to $x$. In contrast, Random Search samples $y$ from the \textbf{hypersphere} of a given radius surrounding $x$.

\paragraph*{Sources.} \url{https://en.wikipedia.org/wiki/Random_search}, \url{https://en.wikipedia.org/wiki/Random_optimization}

\section*{A45) Schwefel's Function}
\textbf{Given:}
$$f_d(X) = \sum\limits_{j=1}^d (-x_j)sin(\sqrt{|x_j|}) \text{ for } -500 \leq x_j \leq +500$$
where $f_d$ denotes that the dimension of the input $X$ is $d$. Let $f(x)$ denote the part of $f_d$ that is dependent of a single variable $x$: 
$$f(x) = (-x)sin(\sqrt{|x|})$$

For $d=1$, $f_1$ has 7 local minima. Therefore, $f(x) = f_1(x)$ has 7 local minima in the given interval as well.
%Also, $f$ is point symmetric in $(0,\dots,0)$: 
%$$-f(X) = -\sum\limits_{j=1}^d (-x_j)sin(\sqrt{|x_j|}) = \sum\limits_{j=1}^d -(-x_j)sin(\sqrt{|x_j|}) = f(-X)$$

Consider $f_d$ with $M(d)$ local minima. Now add a variable $x_{d+1}$ to the input vector and $f(x_{d+1})$ to $f_d$ which yields $f_{d+1}$. Let $m = (m_1, \dots, m_d)$ be a minimum of $f_d$. Then consider $f_{d+1}(m_1, \dots, m_d, x_{d+1}) =  f_d(m) + f(x_{d+1})$ with $m$ fixed and $x_{d+1}$ variable. This function has 7 minima. Since $f_d$ has $M(d)$ local minima, $f_{d+1}$ has $7M(d)$ local minima. With $M(1) = 7$ this yields:
$M(d) = 7^d$.

\section*{A46) Ant Algorithms}
Let's consider the example with ants looking for food. Now, for som reason, let the food move slowly to make the environment dynamic. The ants will begin to search the food, first in a random way, then more and more following the trail of pheromones that is constructed. Since the food is moving, the first trail of pheromones will become meaningless pretty soon, therefore the newer the trail, the better it shows the way to the current position of the food. Older trails become irrelevant and don't fit the environment anymore. To prevent ants from still following them, they should evaporate which can be implemented by an exponential decay.
\end{document}